import * as z from 'zod';
import { Prisma } from '../../../generated/prisma';
import Decimal from 'decimal.js';
import { IntFilterObjectSchema as IntFilterObjectSchema } from './IntFilter.schema';
import { IntNullableFilterObjectSchema as IntNullableFilterObjectSchema } from './IntNullableFilter.schema';
import { StringFilterObjectSchema as StringFilterObjectSchema } from './StringFilter.schema';
import { StringNullableFilterObjectSchema as StringNullableFilterObjectSchema } from './StringNullableFilter.schema';
import { DecimalNullableFilterObjectSchema as DecimalNullableFilterObjectSchema } from './DecimalNullableFilter.schema';
import { EnumProcedureSourceFilterObjectSchema as EnumProcedureSourceFilterObjectSchema } from './EnumProcedureSourceFilter.schema';
import { ProcedureSourceSchema } from '../enums/ProcedureSource.schema';
import { DateTimeFilterObjectSchema as DateTimeFilterObjectSchema } from './DateTimeFilter.schema';
import { AppointmentScalarRelationFilterObjectSchema as AppointmentScalarRelationFilterObjectSchema } from './AppointmentScalarRelationFilter.schema';
import { AppointmentWhereInputObjectSchema as AppointmentWhereInputObjectSchema } from './AppointmentWhereInput.schema';
import { PatientScalarRelationFilterObjectSchema as PatientScalarRelationFilterObjectSchema } from './PatientScalarRelationFilter.schema';
import { PatientWhereInputObjectSchema as PatientWhereInputObjectSchema } from './PatientWhereInput.schema';
import { NpiProviderNullableScalarRelationFilterObjectSchema as NpiProviderNullableScalarRelationFilterObjectSchema } from './NpiProviderNullableScalarRelationFilter.schema';
import { NpiProviderWhereInputObjectSchema as NpiProviderWhereInputObjectSchema } from './NpiProviderWhereInput.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';
const appointmentprocedurewhereinputSchema = z.object({
  AND: z.union([z.lazy(() => AppointmentProcedureWhereInputObjectSchema), z.lazy(() => AppointmentProcedureWhereInputObjectSchema).array()]).optional(),
  OR: z.lazy(() => AppointmentProcedureWhereInputObjectSchema).array().optional(),
  NOT: z.union([z.lazy(() => AppointmentProcedureWhereInputObjectSchema), z.lazy(() => AppointmentProcedureWhereInputObjectSchema).array()]).optional(),
  id: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  appointmentId: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  patientId: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  npiProviderId: z.union([z.lazy(() => IntNullableFilterObjectSchema), z.number().int()]).optional().nullable(),
  procedureCode: z.union([z.lazy(() => StringFilterObjectSchema), z.string()]).optional(),
  procedureLabel: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  fee: z.union([z.lazy(() => DecimalNullableFilterObjectSchema), z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'fee' must be a Decimal",
})]).optional().nullable(),
  category: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  toothNumber: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  toothSurface: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  oralCavityArea: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  source: z.union([z.lazy(() => EnumProcedureSourceFilterObjectSchema), ProcedureSourceSchema]).optional(),
  comboKey: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  createdAt: z.union([z.lazy(() => DateTimeFilterObjectSchema), z.coerce.date()]).optional(),
  appointment: z.union([z.lazy(() => AppointmentScalarRelationFilterObjectSchema), z.lazy(() => AppointmentWhereInputObjectSchema)]).optional(),
  patient: z.union([z.lazy(() => PatientScalarRelationFilterObjectSchema), z.lazy(() => PatientWhereInputObjectSchema)]).optional(),
  npiProvider: z.union([z.lazy(() => NpiProviderNullableScalarRelationFilterObjectSchema), z.lazy(() => NpiProviderWhereInputObjectSchema)]).optional()
}).strict();
export const AppointmentProcedureWhereInputObjectSchema: z.ZodType<Prisma.AppointmentProcedureWhereInput> = appointmentprocedurewhereinputSchema as unknown as z.ZodType<Prisma.AppointmentProcedureWhereInput>;
export const AppointmentProcedureWhereInputObjectZodSchema = appointmentprocedurewhereinputSchema;
